/**
 * @file Bishop.cpp
 * @author Romain Lebbadi-Breteau
 * @version 2.1
 * @date 2022-05-06
 *
 * @copyright Copyright (c) 2022
 *
 * By the way, c'est quoi le STEP ?
 *
 */

#include "Bishop.hpp"

namespace backend {
	void Bishop::computePossibleMoves(std::vector<Coordinate>& possibleMoves) const
	{
		Coordinate delta{ -1, -1 };
		exploreDirection(getPos() + delta, delta, possibleMoves);

		delta.y = 1;
		exploreDirection(getPos() + delta, delta, possibleMoves);

		delta.x = 1;
		exploreDirection(getPos() + delta, delta, possibleMoves);

		delta.y = -1;
		exploreDirection(getPos() + delta, delta, possibleMoves);
	}

	std::string Bishop::getSymbol() const
	{
		if (getSide() == Side::Black) return "♝";
		else return "♗";
	}

	std::ostream& Bishop::print(std::ostream& o) const
	{
		if (getSide() == Side::Black) return o << "\033[1;30mB\033[0m";
		else return o << "\033[1;37mB\033[0m";
	}
}