/**
 * @file InitialPositionsChoice.cpp
 * @author Romain Lebbadi-Breteau
 * @version 2.1
 * @date 2022-05-06
 *
 * @copyright Copyright (c) 2022
 *
 * By the way, c'est quoi le STEP ?
 *
 */
#include "InitialPositionsChoice.hpp"

#include <QBoxLayout>
#include <QLabel>
#include <QApplication>

#include "Window.hpp"

namespace frontend {
	InitialPositionsChoice::InitialPositionsChoice(SelectionWindow* parent, backend::InitialPositions positions) : QWidget(parent), positions_(positions)
	{
		QVBoxLayout* layout = new QVBoxLayout;
		setLayout(layout);

		window_ = dynamic_cast<Window*>(parent->parent());

		QLabel* screenshot = new QLabel;
		window_->resetBoard(positions);
		qApp->processEvents();
		screenshot->setPixmap(window_->screenshot().scaled(256, 256));

		QLabel* legend = new QLabel(positionsNames[static_cast<int>(positions)].data());
		legend->setAlignment(Qt::AlignCenter);

		layout->addWidget(screenshot);
		layout->addWidget(legend);
	}

	void InitialPositionsChoice::mousePressEvent([[maybe_unused]] QMouseEvent* event)
	{
		window_->resetBoard(positions_);
		dynamic_cast<QWidget*>(parent())->hide();
		window_->show();
	}
}