/**
 * @file Knight.hpp
 * @author Romain Lebbadi-Breteau
 * @version 2.1
 * @date 2022-05-06
 *
 * @copyright Copyright (c) 2022
 *
 * By the way, c'est quoi le STEP ?
 *
 */
#pragma once

#include "Piece.hpp"

namespace backend {
	/**
	 * Represents the Knight Piece.
	 */
	class Knight : public Piece
	{
	public:
		using Piece::Piece;

		/**
		 * Puts all the possible moves of the Knight in the given container.
		 */
		void computePossibleMoves(std::vector<Coordinate>&) const override;

		/**
		 * Returns the utf-8 symbol of the Knight depending on the color.
		 */
		std::string getSymbol() const override;

	protected:
		/**
		 * Adds a textual representation of the Knight to the given stream.
		 */
		std::ostream& print(std::ostream& o) const override;
	};
}