/**
 * @file Queen.cpp
 * @author Romain Lebbadi-Breteau
 * @version 2.1
 * @date 2022-05-06
 *
 * @copyright Copyright (c) 2022
 *
 * By the way, c'est quoi le STEP ?
 *
 */

#include "Queen.hpp"

namespace backend {
	Queen::Queen(Side side, Coordinate pos) : Piece(side, pos), Bishop(side, pos), Rook(side, pos)
	{
	}

	void Queen::computePossibleMoves(std::vector<Coordinate>& possibleMoves) const
	{
		Bishop::computePossibleMoves(possibleMoves);
		Rook::computePossibleMoves(possibleMoves);
	}

	std::string Queen::getSymbol() const
	{
		if (getSide() == Side::Black) return "♛";
		else return "♕";
	}

	std::ostream& Queen::print(std::ostream& o) const
	{
		if (getSide() == Side::Black) return o << "\033[1;30mQ\033[0m";
		else return o << "\033[1;37mQ\033[0m";
	}
}