﻿# Chess

Ce jeu d'échecs a été réalisé dans le cadre du projet final du cours INF1015.

## Compilation

Ouvrez le fichier Chess.sln dans Visual Studio 2019, créez une version de Qt
nommée 6.2.4_msvc2019_64 ou modifiez la version de Qt utilisée par le projet.

## Tests

Pour que tous les tests fonctionnent quand vous utilisez le "Test Explorer", il
faut modifier le paramètres "Test Adapter for Google Test" > General >
"Test execution" > "Working Directory" et mettre $(SolutionDir) à la place de
$(ExecutableDir)

## Documentation

Vous pouvez voir la documentation Doxygen en ouvrant <html/index.html> dans
votre navigateur.

## Utilisation

Vous pouvez choisir GUI ou CLI comme valeur de la variable globale gameMode
dans main.cpp pour choisir d'ouvrir le fichier en mode graphique ou console.

Vous pouvez voir à tout moment quel joueur doit faire son déplacement en
regardant le titre actuel de la fenêtre principale.

Vous pouvez déplacer les pièces soit en cliquant sur la pièce à déplacer et
en relâchant la souris sur la case de destination, soit en faisant un clic sur
la case de départ puis un deuxième clic sur la case de destination. Si le
mouvement est invalide, la case de départ clignotera en rouge.

Si un pion arrive à l'autre bout du plateau, il devient automatiquement une
reine, le choix de la pièce sera implémenté plus tard.

Le roque est implémentaté, le roi peut faire le déplacement
de deux cases et la tour passera automatiquement de l'autre côté.

## Menus

Vous avez à votre dispositions 4 actions réparties dans 2 menus :

- Game
	- New game (Ctrl+N)
	- Restart game (Ctrl+R)
- History
	- Previous (Left)
	- Next (Right)

### Jeu

Dans le menu de Jeu (Game) vous pouvez créer une nouvelle partie de n'importe
quel type. Vous pouvez aussi redémarrer la partie dans le mode actuel. Vous
pouvez utiliser les raccourcis Ctrl+N et Ctrl+R respectivement pour effectuer
ces deux actions.

### Historique

À tout moment dans le jeu, vous pouvez utiliser les touches directionnelles
droite et gauche du clavier pour revenir en arrière ou en avant dans la partie.
Vous ne pouvez pas modifier les mouvements effectués quand vous êtes en mode
historique.

## Ajout d'une nouvelle configuration initiale

Vous pouvez ajouter de nouveaux types de configuration initiale en rajoutant un
fichier dans le dossier positions/ avec le contenu suivant pour chaque ligne :

nompiece	posx	posx	cote

Où nompiece peut être pawn, rook, bishop, knight, queen ou king. posx et posy
sont entre 0 et 7, et cote est 0 pour blanc et 1 pour noir.

La dernière ligne doit être vide pour que le fichier soit entièrement lu.

Après avoir créé votre fichier, ajoutez son nom dans la variable
positionsFilenames dans Board.hpp, ajoutez aussi une option dans l'enum
InitialPositions avant l'option Last. Enfin, ajoutez un texte représentant
cette position dans la variable positionsNames de InitialPositionsChoice.hpp

## Informations TD6

Les namespaces sont backend et frontend, pour le modèle et la vue.

Le compteur d'instance est dans la classe King, on peut lancer la création de
trois rois en appuyant sur la touche R dans l'interface graphique.

La classe implémentant le RAII est TemporaryMove. Le mouvement est effectué
dans le constructeur et il est annulé dans le destructeur.