/**
 * @file Rook.cpp
 * @author Romain Lebbadi-Breteau
 * @version 2.1
 * @date 2022-05-06
 *
 * @copyright Copyright (c) 2022
 *
 * By the way, c'est quoi le STEP ?
 *
 */

#include "Rook.hpp"

namespace backend {
	void Rook::computePossibleMoves(std::vector<Coordinate>& possibleMoves) const
	{
		Coordinate delta{ -1, 0 };
		exploreDirection(getPos() + delta, delta, possibleMoves);

		delta.x = 1;
		exploreDirection(getPos() + delta, delta, possibleMoves);

		delta = { 0, -1 };
		exploreDirection(getPos() + delta, delta, possibleMoves);

		delta.y = 1;
		exploreDirection(getPos() + delta, delta, possibleMoves);
	}

	std::string Rook::getSymbol() const
	{
		if (getSide() == Side::Black) return "♜";
		else return "♖";
	}

	std::ostream& Rook::print(std::ostream& o) const
	{
		if (getSide() == Side::Black) return o << "\033[1;30mR\033[0m";
		else return o << "\033[1;37mR\033[0m";
	}
}