/**
 * @file SelectionWindow.cpp
 * @author Romain Lebbadi-Breteau
 * @version 2.1
 * @date 2022-05-06
 *
 * @copyright Copyright (c) 2022
 *
 * By the way, c'est quoi le STEP ?
 *
 */
#include "SelectionWindow.hpp"

#include <QBoxLayout>

#include "Window.hpp"
#include "InitialPositionsChoice.hpp"

namespace frontend
{
	SelectionWindow::SelectionWindow(Window* parent) : QDialog(parent)
	{
		using backend::InitialPositions;

		QHBoxLayout* layout = new QHBoxLayout;
		setLayout(layout);

		for (int positionsIndex = static_cast<int>(InitialPositions::Default); positionsIndex != static_cast<int>(InitialPositions::Last); positionsIndex++)
		{
			InitialPositions positions = static_cast<InitialPositions>(positionsIndex);

			auto* choice = new InitialPositionsChoice(this, positions);
			layout->addWidget(choice);
		}
	}
}