/**
 * @file Side.hpp
 * @author Romain Lebbadi-Breteau
 * @version 2.1
 * @date 2022-05-06
 *
 * @copyright Copyright (c) 2022
 *
 * By the way, c'est quoi le STEP ?
 *
 */
#pragma once

/**
 * Represents a Side on the Board, or player.
 *
 * Every Piece is either Side::White or Side::Black.
 */
enum class Side
{
	White = 0,
	Black = 1,
};

/**
 * Represents the possible contents of a tile on the Board.
 *
 * Each tile either contains a Black Piece, a White Piece, or nothing.
 */
enum class TileType
{
	White = 0,
	Black = 1,
	None = 2
};